[Mesh]
  type = FileMesh
  file = ../meshes/brick.exo
[]

[AuxVariables]
  [temp_test]
  []
  [rho]
    initial_condition = 834.5
  []
  [vel_x]
  []
  [vel_y]
  []
  [vel_z]
  []
  [weighted_temp_xp]
  []
  [weighted_temp_xm]
  []
  [weighted_temp_yp]
  []
  [weighted_temp_ym]
  []
  [weighted_temp_zp]
  []
  [weighted_temp_zm]
  []
[]

[ICs]
  [temp_test]
    type = FunctionIC
    variable = temp_test
    function = temp
  []
  [vel_x]
    type = FunctionIC
    variable = vel_x
    function = vel_x
  []
  [vel_y]
    type = FunctionIC
    variable = vel_y
    function = vel_y
  []
  [vel_z]
    type = FunctionIC
    variable = vel_z
    function = vel_z
  []
[]

[AuxKernels]
  [weighted_temp_xp]
    type = ParsedAux
    variable = weighted_temp_xp
    function = '834.5*vel_x*temp_test'
    args='vel_x temp_test'
  []
  [weighted_temp_xm]
    type = ParsedAux
    variable = weighted_temp_xm
    function = '-834.5*vel_x*temp_test'
    args='vel_x temp_test'
  []
  [weighted_temp_yp]
    type = ParsedAux
    variable = weighted_temp_yp
    function = '834.5*vel_y*temp_test'
    args='vel_y temp_test'
  []
  [weighted_temp_ym]
    type = ParsedAux
    variable = weighted_temp_ym
    function = '-834.5*vel_y*temp_test'
    args='vel_y temp_test'
  []
  [weighted_temp_zp]
    type = ParsedAux
    variable = weighted_temp_zp
    function = '834.5*vel_z*temp_test'
    args='vel_z temp_test'
  []
  [weighted_temp_zm]
    type = ParsedAux
    variable = weighted_temp_zm
    function = '-834.5*vel_z*temp_test'
    args='vel_z temp_test'
  []
[]

[Variables]
  [dummy]
  []
[]

[Kernels]
  [dummy]
    type = Diffusion
    variable = dummy
  []
[]

[BCs]
  [fixed]
    type = DirichletBC
    variable = dummy
    value = 1.0
    boundary = '1'
  []
[]

[Functions]
  [temp]
    type = ParsedFunction
    value = 'exp(x)+sin(y)+x*y*z'
  []
  [vel_x]
    type = ParsedFunction
    value = '1+x*y*z'
  []
  [vel_y]
    type = ParsedFunction
    value = '2+y*exp(z)'
  []
  [vel_z]
    type = ParsedFunction
    value = '3+z*x'
  []
[]

[Executioner]
  type = Transient
  dt = 5e-4
  num_steps = 1
[]

[Outputs]
  csv = true
  execute_on = 'final'
[]

[Postprocessors]
  [weighted_T_side1]
    type = SideIntegralVariablePostprocessor
    variable = weighted_temp_ym
    boundary = '1'
  []
  [weighted_T_side2]
    type = SideIntegralVariablePostprocessor
    variable = weighted_temp_yp
    boundary = '2'
  []
  [weighted_T_side3]
    type = SideIntegralVariablePostprocessor
    variable = weighted_temp_xm
    boundary = '3'
  []
  [weighted_T_side4]
    type = SideIntegralVariablePostprocessor
    variable = weighted_temp_xp
    boundary = '4'
  []
  [weighted_T_side5]
    type = SideIntegralVariablePostprocessor
    variable = weighted_temp_zp
    boundary = '5'
  []
  [weighted_T_side6]
    type = SideIntegralVariablePostprocessor
    variable = weighted_temp_zm
    boundary = '6'
  []
[]
