# Modal Extension

!alert construction prefix=false title=Developer Extension
This extension has no associated syntax for [MooseDown](MooseDocs/specification.md) files.

The Modal extension renders [modal windows](https://en.wikipedia.org/wiki/Modal_window) containing
code content and generates the anchor elements to trigger them. The tokens may either include a
string of content explicitly or the absolute path of a project file to read content from. These
tokens spawn from other MooseDocs extensions. For example, an automatic link to a source file
creates a modal displaying its complete content, as demonstrated in [modal-example].

!devel example id=modal-example
               caption=Modal trigger generated by the
                       [AutoLink extension](MooseDocs/extensions/autolink.md#source).
[framework/src/kernels/Diffusion.C]

!alert note title=The Modal extension is for code only
Currently, the Modal extension is strictly for displaying code content. An extension may still
create modals that display other types of content by using the appropriate
[style classes](framework/doc/content/css/moose.css language=css). For example, the search button at
the top of this page triggers a modal created by the
[Navigation extension](python/MooseDocs/extensions/navigation.py).

## Configuration

The Modal extension implements a procedure to prevent the display of file contents, which helps to
ensure that sensitive or proprietary information is not accidentally revealed to the public, as
multiple extensions create these tokens. For example, the `!syntax inputs` command from the
[Application Syntax extension](MooseDocs/extensions/appsyntax.md#inputs) generates a list of MOOSE
input files. But toggling the `hide_source` option (see [modal-config]) disables the modal triggers
leaving filenames rendered as plain text.

!devel settings id=modal-config caption=Configuration options for the Modal extension.
                module=MooseDocs.extensions.modal object=ModalExtension

The options listed in [modal-config] are set via the [configuration file](MooseDocs/config.md). The
`hide_source` option prevents displaying *all* source files, not just, e.g., C++ files. Hence, the
`exceptions` option provides a means for handpicking files deemed safe to reveal, and the
configuration below demonstrates its use.

!listing python/MooseDocs/test/config.yml
         language=yaml
         start=MooseDocs.extensions.modal:
         end=MooseDocs.extensions.datetime: default
